#!/usr/bin/perl

#------------------------------------------------------------------------------
# v1.0 (C) 17-Sep-2002 by Hard Wisdom

# usage: no parameters

$comment = 'Dump statistics about System usage';
@format = ('DS:value:GAUGE:600:0:U');
($noavg, $nomax, $nomin) = (undef(), undef(), undef());

#------------------------------------------------------------------------------
# We're going to reload configuration, clear all acquired data sources
sub reload { undef @DBASE; $CMD = '/usr/bin/uptime' }

#------------------------------------------------------------------------------
# Acquire data source to use for subsequent updates
sub acquire { push @DBASE, $_[0] }

#------------------------------------------------------------------------------
# Emit data for graphing to call site
sub graph
{
	my ($hint, $database) = @_;
	return <<CGI unless $hint;
--vertical-label "Percents" --lower-limit 0 --units-exponent 0 --alt-y-grid
DEF:load_avg=$database:value:AVERAGE
DEF:load_peak=$database:value:MAX
DEF:load_idle=$database:value:MIN

CDEF:load_ratio=load_peak,load_idle,/

LINE2:load_peak#FF00FF:"Load percentage, peak"
LINE2:load_idle#00CF00:"Load percentage, idle"
LINE2:load_avg#0000FF:"Load percentage, average\\n"
COMMENT:"Load"
GPRINT:load_peak:LAST:"%.2lf %%"
COMMENT:"Deviation"
GPRINT:load_ratio:LAST:"%.2lf"
CGI

	return <<CGI;
--vertical-label "Percents" --lower-limit 0 --units-exponent 0 --no-legend
DEF:load_avg=$database:value:AVERAGE
DEF:load_peak=$database:value:MAX
DEF:load_idle=$database:value:MIN

LINE2:load_peak#FF00FF
LINE2:load_idle#00CF00
LINE2:load_avg#0000FF
CGI

}

#------------------------------------------------------------------------------
# Read data sources and update database
sub update
{
	my ($file); my ($item) = `$CMD`;
	$item =~ /load averages:\s+(.*?),\s+(.*?),\s+(.*)/;
	for $file (@DBASE)
	{
		::WARN "Unable to update data for '$file', cause: ".RRDs::error
		unless RRDs::update $file,
		                    '--template',
		                    'value',
		                    "N:".($2*10);
	}
}

#------------------------------------------------------------------------------
# Inspect BOX configuration and produce initial configuration file
sub wizard { return (['load', "Total System Load", undef()]) }

